#include <epicsEvent.h>
#include "ADDriver.h"

#define SimGainXString          "SIM_GAIN_X"
#define SimGainYString          "SIM_GAIN_Y"
#define SimNoiseString          "SIM_NOISE"

/** Simulation detector driver; demonstrates most of the features that areaDetector drivers can support. */
class epicsShareClass simDetector : public ADDriver {
public:
    simDetector(const char *portName, int maxSizeX, int maxSizeY, NDDataType_t dataType,
                int maxBuffers, size_t maxMemory,
                int priority, int stackSize);

    /* These are the methods that we override from ADDriver */
    virtual asynStatus writeInt32(asynUser *pasynUser, epicsInt32 value);
    virtual void report(FILE *fp, int details);
    void simTask(); /**< Should be private, but gets called from C, so must be public */

protected:
    int SimGainX;
    #define FIRST_SIM_DETECTOR_PARAM SimGainX
    int SimGainY;
    int SimNoise;
    #define LAST_SIM_DETECTOR_PARAM SimNoise

private:
    /* These are the methods that are new to this class */
    int computeImage();

    /* Our data */
    epicsEventId startEventId;
    epicsEventId stopEventId;
};

#define NUM_SIM_DETECTOR_PARAMS ((int)(&LAST_SIM_DETECTOR_PARAM - &FIRST_SIM_DETECTOR_PARAM + 1))

